unit GameUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 
  
const
  C_Empty = 0;
  C_Wall = 1;

var
  Field: array of array of Byte;
  FieldWidth, FieldHeight: Integer;

procedure CreateField(AFieldWidth, AFieldHeight: Integer);
function SaveField(AFilename: TFilename): Boolean;
function LoadField(AFilename: TFilename): Boolean;

implementation

procedure CreateField(AFieldWidth, AFieldHeight: Integer);
var
  X, Y: Integer;
begin
  SetLength(Field, AFieldWidth, AFieldHeight);
  FieldWidth := AFieldWidth;
  FieldHeight := AFieldHeight;
  
  for Y := 0 to FieldHeight - 1 do
    for X := 0 to FieldWidth - 1 do
      Field[X, Y] := C_Empty;
end;

function SaveField(AFilename: TFilename): Boolean;
var
  S: TFileStream;
  X, Y: Integer;
begin
  Result := False;
  try
    S := TFileStream.Create(AFilename, fmCreate);
    S.Write(FieldWidth, SizeOf(FieldWidth));
    S.Write(FieldHeight, SizeOf(FieldHeight));
    for Y := 0 to FieldHeight - 1 do
      for X := 0 to FieldWidth - 1 do
        S.Write(Field[X, Y], SizeOf(Field[X, Y]));
    Result := True;
  finally
    S.Free;
  end;
end;

function LoadField(AFilename: TFilename): Boolean;
var
  S: TFileStream;
  X, Y: Integer;
begin
  Result := False;
  try
    S := TFileStream.Create(AFilename, fmOpenRead);
    S.Read(FieldWidth, SizeOf(FieldWidth));
    S.Read(FieldHeight, SizeOf(FieldHeight));
    CreateField(FieldWidth, FieldHeight);
    for Y := 0 to FieldHeight - 1 do
      for X := 0 to FieldWidth - 1 do
        S.Read(Field[X, Y], SizeOf(Field[X, Y]));
    Result := True;
  finally
    S.Free;
  end;
end;

begin
  CreateField(32, 32);
end.

